// EXAMPLE 2
// draw different shapes and respond to keyboard input
#include <iostream>
#include <gl/glut.h>
using namespace std;

int shape = 1;

void init( void )
{
	// set background to white
	glClearColor(1.0, 1.0, 1.0, 0.0);

	glMatrixMode (GL_PROJECTION);
	gluOrtho2D(-1.0, 1.0, -1.0, 1.0);
	glMatrixMode (GL_MODELVIEW);
}

// Main drawing routine. Called repeatedly by GLUT's main loop
void display( void )
{
   //Clear the screen and set our initial view matrix
   glClear(GL_COLOR_BUFFER_BIT);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   //TODO: Perform drawing here
	switch (shape)
	{
	case 1:
		// draw points
		// set point size and color
		glPointSize(10.0);
		glColor3f(1.0, 0.0, 0.0);
		glBegin(GL_POINTS);
			glVertex2f(0.0, 0.5);
		glEnd();

		glPointSize(20.0);
		glColor3f(0.6, 0.6, 0.0);
		glBegin(GL_POINTS);
			glVertex2f(-0.43, -0.25);
		glEnd();

		glPointSize(5.0);
		glColor3f(0.0, 0.0, 1.0);
		glBegin(GL_POINTS);
			glVertex2f(0.43, -0.25);
		glEnd();
		break;
	case 2:
		// draw line segments
		// set line width
		glColor3f(0.0, 0.0, 1.0);
		glLineWidth(2.5);
		glBegin(GL_LINES);
			glVertex2f(-0.5, 0.5);
			glVertex2f(0.5, 0.5);
		glEnd();

		glColor3f(1.0, 0.0, 0.0);
		glLineWidth(4.0);
		glBegin(GL_LINES);
			glVertex2f(-0.5, -0.5);
			glVertex2f(0.5, -0.5);
		glEnd();
		break;
	case 3:
		// draw triangle
		glBegin(GL_TRIANGLES);
			glColor3f(1.0, 0.0, 0.0);
			glVertex2f(0.0, 0.5);
			glColor3f(0.0, 1.0, 0.0);
			glVertex2f(-0.43, -0.25);
			glColor3f(0.0, 0.0, 1.0);
			glVertex2f(0.43, -0.25);
		glEnd();
		break;
	}

   glutSwapBuffers();
}

// keyboard event callback function
void keyboard(unsigned char key, int x, int y)
{
	// switch the shape to draw according to user input
	if (key == '1')
	{
		shape = 1;
	}
	else if (key == '2')
	{
		shape = 2;
	}
	else if (key == '3')
	{
		shape = 3;
	}
	else if (key == 'q' || key == 'Q')
	{
		// case insensitive
		exit(0);
	}

	// force redraw
	glutPostRedisplay();
}

// Entry point - GLUT setup and initialization
int main( int argc, char** argv )
{

  glutInit( &argc, argv );
  glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize (300, 300);
  glutInitWindowPosition (100, 100);
  glutCreateWindow( "Example 2" );
  glutDisplayFunc( display );

  // register a keyboard function
  glutKeyboardFunc( keyboard );

  init();

  glutMainLoop();

  return 0;
}